/* CSE303, Spring 2007, Homework 3, Problem 2 */

/* A simple program to help find words in a "Boggle (TM) like" situation*/
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>

char * progname;

// No need to change next 3 functions
void usage() {
  fprintf(stderr,"usage: %s grid-size grid-file\n",progname);
  exit(1);
}
void bad_grid() {
  fprintf(stderr,"%s: grid is too small\n",progname);
  exit(1);
}
void bad_word(int max) {
  fprintf(stderr,"%s: word must be only letters and less than size %d; please reenter\n",progname,max);
}

char ** make_grid(int gridsize,FILE * file) {
  char ** ans = (char**)malloc(gridsize*sizeof(char*));
  int i;
  for(i=0; i < gridsize; ++i)
    ans[i] = (char*)malloc(gridsize*sizeof(char));
  char * input_buffer = (char*)malloc((gridsize+2)*sizeof(char));
  int    lines_read   = 0;
  for(; lines_read < gridsize; ++lines_read) {
    if(!fgets(input_buffer,gridsize+2,file))
      bad_grid();
    if(strlen(input_buffer) < gridsize+1) // +1 because of \n
      bad_grid();
    strncpy(ans[lines_read],input_buffer,gridsize); // do not copy the \n

    // HINT: put some code here; no need to change the rest of the function

  }
  free(input_buffer);
  return ans;
}

char * read_word(int max_size) {
  char * ans = (char*)malloc((max_size+2)*sizeof(char));
  if(!fgets(ans,max_size+2,stdin)) {
    bad_word(max_size);
    return read_word(max_size);
  }
  int len_with_newline = strlen(ans);
  if(len_with_newline==1) // they are done playing
    exit(0);
  if(len_with_newline==max_size+1 && ans[max_size] != '\n') { //word too big
    bad_word(max_size);
    return read_word(max_size);
  }
  ans[len_with_newline-1]='\0'; //put \0 where the \n was

  // HINT: put some code here; no need to change the rest of the function

  return ans;
}

// Note: better style would be separating the I/O into other functions

// HINT: need to change arguments slightly
int find_word (int grid_size, char ** grid, char * word, 
	       int start_row, int start_col,
	       int word_index, int curr_row, int curr_col) {

  if(!word[word_index]) { // hit nul-terminator of string: success
    // HINT: need to change this
    printf("found, start at row %d column %d\n", start_row+1, start_col+1);
    return 1;
  }
 
  if(curr_row < 0 || curr_row >= grid_size // fell off the grid
     || curr_col < 0 || curr_col >= grid_size)
    return 0;
   
  if(grid[curr_row][curr_col] != word[word_index]) // no match
    return 0;

  // HINT: put code here to see if "we have been here before"
 
  // HINT: remember to look for diagonals

  int steps[4][2] = {{1,0},{0,-1},{-1,0},{0,1}};
  int step_index = 0;
  
  // HINT: make changes below to keep track of where we have been
  for(; step_index < 4; ++step_index)
    if(find_word(grid_size,grid,word,start_row,start_col, // recur
		 word_index+1,
		 curr_row+steps[step_index][0],
		 curr_col+steps[step_index][1]))
      return 1;

  return 0;
}

// HINT: need to create and pass some arrays -- do not leak space!
void find_whole_word(int grid_size, char ** grid, char * word) {
  int start_row;
  int start_col;
  for(start_row=0; start_row < grid_size; ++start_row)
    for(start_col=0; start_col < grid_size; ++start_col)
      if(find_word(grid_size,grid,word,start_row,start_col,
		   0,start_row,start_col))
	return;
  printf("word not found\n");
}

// no reason to change this function
int main(int argc, char ** argv) {
  progname = argv[0];
  if(argc != 3)
    usage();
  int    gridsize = atoi(argv[1]);
  FILE * file     = fopen(argv[2],"r");
  if(gridsize <= 0 || !file)
    usage();
  char ** grid = make_grid(gridsize,file);
  while(1) {
    fprintf(stdout,"enter word to find (enter to quit):\n");
    int max_size = gridsize*gridsize;
    char * word = read_word(max_size);
    find_whole_word(gridsize,grid,word);
    free(word);
  }
  return 0;
}
